#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 1e5+45;

int w,h,r,q;
ld ans[N];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(12);
    cout << fixed;
    cin >> w >> h >> r >> q;
    for(int i = 0; i <= w; i++){
        ans[i] = h;
    }
    for(int i = 1; i <= q; i++){
        int t;
        cin >> t;
        if(t == 1){
            int xi,yi;
            cin >> xi >> yi;
            for(int xj = max(0,xi-r); xj <= min(w,xi+r); xj++){
                ld koren = sqrt(ld(r*r-(xi-xj)*(xi-xj)));
                ld yj = ld(yi-koren);
                ans[xj] = min(ans[xj],yj);
            }
        }
        else{
            int x;
            cin >> x;
            cout << ans[x] << endl;
        }
    }
}